{$N-}
uses RTC_MAIN,RTC_BR,RTC_ERR,TIME;

var
    Code:string;
    CodePtr:pointer;
    CodeSize:word;
    MyFunc: function (x,y,z:float):float;
    err,errp:integer;

procedure InitCode(s:string);
var SC:PSmallCompiler;
begin
  SC:=New(PCompilerForBorlandReal,Init(
          Var_('x',
          Var_('y',
          Var_('z',nil)))));

  with SC^ do
    begin
    SetData(s,err,errp,CodeSize);
    if err<>0 then Error(s,err,errp);
    GetMem(CodePtr,CodeSize);
    GetCode(@MyFunc,CodePtr^);
    end;
  Dispose(SC,Done);
end;

function TimeTest1(x,y,z:float):float;
begin
  TimeTest1:=x+y+z;
end;

function TimeTest2(x,y,z:float):float;
begin
  TimeTest2:=sin(x)+y/z+ln(z);
end;

function TimeTest3(x,y,z:float):float;
begin
  TimeTest3:=sin(ln(x))+y/(z-1)*ln(cos(z*10));
end;



var r:float;
    s:string;
    i:word;
    start,worktime1,worktime2:longint;
begin
  writeln('                Working without coprocessor...');

 s:='x+y+z';
 InitCode(s);
 start:=clock;
 for i:=1 to 10000 do
   r:=MyFunc(1,2,3);
 worktime1:=clock-start;
 FreeMem(CodePtr,CodeSize);
 start:=clock;
 for i:=1 to 10000 do
   r:=TimeTest1(1,2,3);
 worktime2:=clock-start;
 writeln('decrease speed for f(x,y,z)=',s,':   ',100*(worktime1-worktime2)/worktime1:0:2,'%');

 s:='sin(x)+y/z+ln(z)';
 InitCode(s);
 start:=clock;
 for i:=1 to 1000 do
   r:=MyFunc(1,2,3);
 worktime1:=clock-start;
 FreeMem(CodePtr,CodeSize);
 start:=clock;
 for i:=1 to 1000 do
   r:=TimeTest2(1,2,3);
 worktime2:=clock-start;
 writeln('decrease speed for f(x,y,z)=',s,':   ',100*(worktime1-worktime2)/worktime1:0:2,'%');

 s:='sin(ln(x))+y/(z-1)*ln(cos(z*10))';
 InitCode(s);
 start:=clock;
 for i:=1 to 1000 do
   r:=MyFunc(1,2,3);
 worktime1:=clock-start;
 FreeMem(CodePtr,CodeSize);
 start:=clock;
 for i:=1 to 1000 do
   r:=TimeTest3(1,2,3);
 worktime2:=clock-start;
 writeln('decrease speed for f(x,y,z)=',s,':   ',100*(worktime1-worktime2)/worktime1:0:2,'%');
end.

